    View Javadoc
    1   package org.apache.bcel.generic;
    2
    3   /* ====================================================================
    4    * The Apache Software License, Version 1.1
    5    *
    6    * Copyright (c) 2001 The Apache Software Foundation.  All rights
    7    * reserved.
    8    *
    9    * Redistribution and use in source and binary forms, with or without
    10   * modification, are permitted provided that the following conditions
    11   * are met:
    12   *
    13   * 1. Redistributions of source code must retain the above copyright
    14   *    notice, this list of conditions and the following disclaimer.
    15   *
    16   * 2. Redistributions in binary form must reproduce the above copyright
    17   *    notice, this list of conditions and the following disclaimer in
    18   *    the documentation and/or other materials provided with the
    19   *    distribution.
    20   *
    21   * 3. The end-user documentation included with the redistribution,
    22   *    if any, must include the following acknowledgment:
    23   *       "This product includes software developed by the
    24   *        Apache Software Foundation (http://www.apache.org/)."
    25   *    Alternately, this acknowledgment may appear in the software itself,
    26   *    if and wherever such third-party acknowledgments normally appear.
    27   *
    28   * 4. The names "Apache" and "Apache Software Foundation" and
    29   *    "Apache BCEL" must not be used to endorse or promote products
    30   *    derived from this software without prior written permission. For
    31   *    written permission, please contact apache@apache.org.
    32   *
    33   * 5. Products derived from this software may not be called "Apache",
    34   *    "Apache BCEL", nor may "Apache" appear in their name, without
    35   *    prior written permission of the Apache Software Foundation.
    36   *
    37   * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
    38   * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
    39   * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
    40   * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
    41   * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
    42   * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
    43   * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
    44   * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
    45   * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
    46   * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
    47   * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    48   * SUCH DAMAGE.
    49   * ====================================================================
    50   *
    51   * This software consists of voluntary contributions made by many
    52   * individuals on behalf of the Apache Software Foundation.  For more
    53   * information on the Apache Software Foundation, please see
    54   * <http://www.apache.org/>;.
    55   */
    56  import org.apache.bcel.classfile.*;
    57
    58  /***
    59   * Super class for InvokeInstruction and FieldInstruction, since they have
    60   * some methods in common!
    61   *
    62   * @version $Id: FieldOrMethod.java,v 1.1.1.1 2001/10/29 20:00:13 jvanzyl Exp $
    63   * @author  <A HREF="mailto:markus.dahm@berlin.de">M. Dahm</A>
    64   */
    65  public abstract class FieldOrMethod extends CPInstruction implements LoadClass {
    66    /***
    67     * Empty constructor needed for the Class.newInstance() statement in
    68     * Instruction.readInstruction(). Not to be used otherwise.
    69     */
    70    FieldOrMethod() {}
    71
    72    /***
    73     * @param index to constant pool
    74     */
    75    protected FieldOrMethod(short opcode, int index) {
    76      super(opcode, index);
    77    }
    78
    79    /*** @return signature of referenced method/field.
    80     */
    81    public String getSignature(ConstantPoolGen cpg) {
    82      ConstantPool        cp   = cpg.getConstantPool();
    83      ConstantCP          cmr  = (ConstantCP)cp.getConstant(index);
    84      ConstantNameAndType cnat = (ConstantNameAndType)cp.getConstant(cmr.getNameAndTypeIndex());
    85
    86      return ((ConstantUtf8)cp.getConstant(cnat.getSignatureIndex())).getBytes();
    87    }
    88
    89    /*** @return name of referenced method/field.
    90     */
    91    public String getName(ConstantPoolGen cpg) {
    92      ConstantPool        cp   = cpg.getConstantPool();
    93      ConstantCP          cmr  = (ConstantCP)cp.getConstant(index);
    94      ConstantNameAndType cnat = (ConstantNameAndType)cp.getConstant(cmr.getNameAndTypeIndex());
    95      return ((ConstantUtf8)cp.getConstant(cnat.getNameIndex())).getBytes();
    96    }
    97
    98    /*** @return name of the referenced class/interface
    99     */
    100   public String getClassName(ConstantPoolGen cpg) {
    101     ConstantPool cp  = cpg.getConstantPool();
    102     ConstantCP   cmr = (ConstantCP)cp.getConstant(index);
    103     return cp.getConstantString(cmr.getClassIndex(), org.apache.bcel.Constants.CONSTANT_Class).replace('/', '.');
    104   }
    105
    106   /*** @return type of the referenced class/interface
    107    */
    108   public ObjectType getClassType(ConstantPoolGen cpg) {
    109     return new ObjectType(getClassName(cpg));
    110   }
    111
    112   /*** @return type of the referenced class/interface
    113    */
    114   public ObjectType getLoadClassType(ConstantPoolGen cpg) {
    115     return getClassType(cpg);
    116   }
    117 }

This page was automatically generated by Maven